#! /usr/bin/perl

# Accessible Chat Utility Functions
# Copyright 2004, Adaptive Technology Resource Centre, U of Toronto
# Written by: Taras Kowaliw, taras.kowaliw@utoronto.ca
# Last Modified: 04.05.04 by Boon-Hau Teh, boonhau.teh@utoronto.ca

# Initialize Global Variables
%prefs;
%admin;
%form;
&getAdminSettings();
$loginURL = $admin{"cgiURL"} . "login.pl";
$displayURL = $admin{"cgiURL"} . "display.pl";
$htmlURL = $admin{"htmlURL"};
$htmlDir = $admin{"htmlDir"};
$tranDir = $htmlDir . "tran/";
$errDir = $htmlDir . "error/";
$miscURL = $admin{"cgiURL"} . "misc.pl";
$bingURL = $admin{"cgiURL"} . "bing.pl";
$soundFile = $htmlURL . "chime.au";
$bottomMsgNum = 0;
$topMsgNum = 0;

$language = $admin{"language"};
@systemtext = ();

&readLanguage ($language, "chatutils", systemtext);


# Open a text file in a language directory and read lines into a text array.
# If fail to open in any other directory, read from "English" directory.
# Reference:
#   $_[0] = language;
#   $_[1] = filename;
#   $_[2] = textarray;
sub readLanguage{
   $row = 0;

   @variables;
   $variables[0] = "<CHATNAME>";             # Name of Chat room
   $variables[1] = "<RETURNLINK>";           # Return Link
   $variables[2] = "<RETURNTEXT>";           # Return Text
   $variables[3] = "<MSGLIFESPAN>";          # Message Life Span
   $variables[4] = "<CHATSESSIONLIFESPAN>";  # Chat Session Life Span
   $variables[5] = "<CHATIDLIFESPAN>";       # Chat ID Life Span
   $variables[6] = "<URLMAIN>";              # Root URL for current chat room

   %varvalue;
   $varvalue {"<CHATNAME>"} = $admin{"chatName"};
   $varvalue {"<RETURNLINK>"} = $admin{"returnL"};
   $varvalue {"<RETURNTEXT>"} = $admin{"returnT"};
   $varvalue {"<MSGLIFESPAN>"} = $admin{"msgLifeSpan"};
   $varvalue {"<CHATSESSIONLIFESPAN>"} = $admin{"chatSessionLifeSpan"};
   $varvalue {"<CHATIDLIFESPAN>"} = $admin{"chatIDLifeSpan"};
   $varvalue {"<URLMAIN>"} = $htmlURL;

   open (fp, "<$cgiDIR"."language/$_[0]/$_[1].txt") || open (fp, "<$cgiDIR"."language/English/$_[1].txt");
   while ($line = <fp>){
      chomp ($line);
      for ($i = 0; $i < 7; $i++) {
          $line =~ s/$variables[$i]/$varvalue{$variables[$i]}/g;
      }
      $_[2][$row++] = $line;
   }
   close (fp);
}


sub getCGI {
  if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        @pairs = split(/&/, $ENV{'QUERY_STRING'});
  } elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @pairs = split(/&/, $buffer);
  }
  foreach $pair (@pairs) {
    local($name, $value) = split(/=/, $pair);
    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $form{$name} = $value;
  }
}

sub getPrefs {
    open(PREFS,"<$cgiDIR"."users/$chatID.prefs");
    foreach $prefLine (<PREFS>) {
        chomp($prefLine);
        ($keyT,$valueT) = split("=",$prefLine);
        $keyT =~ s/=//;
        $prefs{$keyT} = $valueT;
    }
    close(PREFS);
    $iT = 0;
    
    # Having some difficulties locking the file... doesn't work
    # on snow, won't work in Windows anyways.
    # Here's a little hack that fixes it, although
    # not particularily well. It works
    # during my testing though.
    while (!$prefs{"uniqueID"} && $iT < 8) {
       sleep 1;
       $iT ++;
       #print "$iT\n";
       open(PREFS,"<$cgiDIR"."users/$chatID.prefs");
       foreach $prefLine (<PREFS>) {
           chomp($prefLine);
           ($keyT,$valueT) = split("=",$prefLine);
           $keyT =~ s/=//;
           $prefs{$keyT} = $valueT;
       }
       close(PREFS);
    }
    $prefs{"lastAccessed"} = time;
    if ($prefs{"colours"} =~ /beigeBlack/) {
        $prefs{"back"} = "beige";
        $prefs{"front"} = "black";
        $prefs{"lightBack"} = "#ddeecc";
        $prefs{"darkBack"} = "#bbccaa";
    } elsif ($prefs{"colours"} =~ /whiteBlack/) {
        $prefs{"back"} = "white";
        $prefs{"front"} = "black";
        $prefs{"lightBack"} = "#ddeecc";
        $prefs{"darkBack"} = "#bbccaa";
    } elsif ($prefs{"colours"} =~ /whiteBlue/) {
        $prefs{"back"} = "white";
        $prefs{"front"} = "000066";
        $prefs{"lightBack"} = "#ffddcc";
        $prefs{"darkBack"} = "#ddbbaa";
    } elsif ($prefs{"colours"} =~ /blackYellow/) {
        $prefs{"back"} = "black";
        $prefs{"front"} = "yellow";
        $prefs{"lightBack"} = "#333333";
        $prefs{"darkBack"} = "#666666";
    } elsif ($prefs{"colours"} =~ /blackWhite/) {
        $prefs{"back"} = "black";
        $prefs{"front"} = "white";
        $prefs{"lightBack"} = "#333333";
        $prefs{"darkBack"} = "#666666";
    } else { # blueWhite
        $prefs{"back"} = "#000033";
        $prefs{"front"} = "white";
        $prefs{"lightBack"} = "#000066";
        $prefs{"darkBack"} = "#333366";    
    }
}

sub cleanUp {
    $msgLifeSpan = $admin{"msgLifeSpan"};
    $chatSessionLifeSpan = $admin{"chatSessionLifeSpan"};
    $chatIDLifeSpan = $admin{"chatIDLifeSpan"};
    if (!$msgLifeSpan || !$chatSessionLifeSpan || !$chatIDLifeSpan) {
        print "Nope, something missing: $msgLifeSpan, $chatSessionLifeSpan, $chatIDLifeSpan<br />\n";
    } else {

        # Clean up messages
        chomp ($systemtext[4]);
        chomp ($systemtext[5]);
        opendir(MSGS,"$cgiDIR"."msgs") || &printError("$systemtext[4] $cgiDIR $systemtext[5]","$!");
        @msgs = readdir(MSGS);
        closedir(MSGS);
        foreach $msgFileT (@msgs) {
            if ($msgFileT =~ /.message/) {
                @foo = stat("msgs/$msgFileT");
                if (time - $foo[9] > $msgLifeSpan) {
                    unlink("msgs/$msgFileT");
                }
            }
        }
        
        
        # Clean up inactive users
        opendir(USERS,"$cgiDIR"."users") || &printError($systemtext[7],"$!");
        @users = readdir(USERS);
        closedir(USERS);
        foreach $userFileT (@msgs) {
            if ($userFileT =~ /.prefs/) {
                $userFileT =~ s/.prefs//;
                $lA = &getLastAccessed($userFileT);
                if (time - $lA > $chatSessionLifeSpan && $lA > 0) {
                    chomp ($systemtext[9]);
                    chomp ($systemtext[11]);
                    $systemtext[11] =~ s/<CHATID>/$userFileT/g;
                    &postMessage($systemtext[9],$systemtext[11]);
                    &resetLastAccessed($userFileT);
                }
            }
        }
        
    }
    &howManyMessages();
}

sub clearOutOldChatPrefs {
    # Clear out old user names
    opendir(USERS,"$cgiDIR"."users") || &printError("","$!");
    @userFiles = readdir(USERS);
    closedir(USERS);
    foreach $fileT (sort @userFiles) {
        if ($fileT =~ /.prefs/) {
            $fileT =~ s/\.prefs//;
            $lL = &getLastLogin($fileT);
            $fooT = time;
            if ($admin{"chatIDLifeSpan"} && $fooT - $lL > $admin{"chatIDLifeSpan"}) {
                print "$systemtext[14] $fileT<br />\n";
                &deleteUser($fileT);
            }
        }
    }       
}

sub resetLastAccessed {
    $tempChatID = @_[0];
    open(LA,">$cgiDIR"."users/$tempChatID.la") || &printError($systemtext[16],"$!");
    flock(LA,2);
    print LA "0\n";
    close(LA);
    chmod (0666, "$cgiDIR"."users/$tempChatID.la");     
}

sub getLastAccessed {
    $tempChatID = @_[0];
    open(LA,"<$cgiDIR"."users/$tempChatID.la") || &printError("$systemtext[18] $tempChatID","$!");
    chomp ($tempLineT = <LA>);
    close(LA);
    return $tempLineT;
}

sub getLastLogin {
    $tempChatID = @_[0];
    local (%otherPrefs);
    open(PREFS,"<$cgiDIR"."users/$tempChatID.prefs");
    foreach $prefLine (<PREFS>) {
        chomp($prefLine);
        ($keyT,$valueT) = split("=",$prefLine);
        $keyT =~ s/=//;
        $otherPrefs{$keyT} = $valueT;
    }
    close(PREFS);
    $iT = 0;
    while (!$otherPrefs{"lastLogin"} && $iT < 3) {
       sleep 1;
       $iT ++;
       #print "$iT\n";
       open(PREFS,"<$cgiDIR"."users/$tempChatID.prefs");
       foreach $prefLine (<PREFS>) {
           chomp($prefLine);
           ($keyT,$valueT) = split("=",$prefLine);
           $keyT =~ s/=//;
           $otherPrefs{$keyT} = $valueT;
       }
       close(PREFS);
    }
    return $otherPrefs{"lastLogin"};
}


sub writePrefs {
    open(PREFS,">$cgiDIR"."users/$chatID.prefs") || &printError($systemtext[20],"$!");
    flock(PREFS,2);
    foreach $prefKey (keys %prefs) {
        $veryT = $prefs{"$prefKey"};
        print PREFS "$prefKey=$veryT\n";
    }
    close(PREFS);
    chmod (0666, "$cgiDIR"."users/$chatID.prefs"); 

    open(LA,">$cgiDIR"."users/$chatID.la") || &printError($systemtext[20],"$!");
    flock(LA,2);
    print LA "$prefs{'lastAccessed'}\n";
    close(LA);
    chmod (0666, "$cgiDIR"."users/$chatID.la");

    open (AL, ">$cgiDIR"."users/$chatID.al") || &printError ($systemtext[20], "$!");
    flock (AL, 2);
    print AL "$prefs{'accessLevel'}\n$prefs{'colour'}\n";
    close (AL);
    chmod (0666, "$cgiDIR"."users/$chatID.al");
}


sub defaultPrefs {
    $prefs{"colours"} = "beigeBlack";
    $prefs{"back"} = "beige";
    $prefs{"lightBack"} = "#ddeecc";
    $prefs{"darkBack"} = "#bbccaa";
    $prefs{"front"} = "black";
    $prefs{"fontSize"} = 12;
    $prefs{"fontFace"} = "arial";
    $prefs{"idColour"} = "black";
    $prefs{"bingFlag"} = 0;
    $prefs{"onlyNewFlag"} = 0;
    $prefs{"newestFirstFlag"} = 1;
    $prefs{"navigationAidFlag"} = 0;
    $prefs{"refresh"} = 5;
    $prefs{"lastRead"} = 0;
    $prefs{"lastChecked"} = 0;
    $prefs{"lastAccessed"} = time;
    $prefs{"accessLevel"} = 2;
}

sub printError {
    ($errMsgT1, $errMsgT2) = @_;
    chomp ($systemtext[22]);
    $systemtext[22] =~ s/<LOGINURL>/$loginURL/g;
    print "$systemtext[22]<br />\n";
    print "$errMsgT1 <br />\n";
    print "$errMsgT2 <br />\n";
    if ($admin{"produceLog"} == 1) {
       $dateT = scalar (localtime);
       open (ERROR,">> $errDir"."/$admin{'errLog'}") || die "Failed to open error log file";
       print ERROR "<br><b>$dateT: </b>$errMsgT1 - $errMsgT2 ";
       close(ERROR);
    }
    exit(0);
}

sub securityCheck {
    $tempID = @_[0];
    if ($prefs{"uniqueID"} =~ /$tempID/ && $tempID =~ /$prefs{"uniqueID"}/) {
        return 1;
    }
    return 0;
}

sub getAdminSettings {
    open(ADMIN,"<$cgiDIR"."admin.settings") || &printError($systemtext[25],"$!");
    foreach $adminLine (<ADMIN>) {
        chomp($adminLine);
        ($keyT,$valueT) = split("=",$adminLine);
        $keyT =~ s/=//;
        $admin{$keyT} = $valueT;
    }
    close(ADMIN);
    if ($admin{"returnT"} && $admin{"returnL"}) {
        $admin{"returnLink"} = "<a href=\"$admin{'returnL'}\">$admin{'returnT'}</a>";
    } else {
        $admin{"returnLink"} = "";
    }
}

sub writeAdminSettings {
    open(ADMIN,">$cgiDIR"."admin.settings") || &printError($systemtext[27],"$!");
    foreach $adminKey (keys %admin) {
        $veryT = $admin{"$adminKey"};
        print ADMIN "$adminKey=$veryT\n";
    }
    close(ADMIN);
    chmod (0666, "$cgiDIR"."admin.settings"); 
}

sub defaultAdminSettings {
    $admin{"language"} = "English";
    $admin{"cgiURL"} = "http://snow.utoronto.ca/cgi/achat/";
    $admin{"htmlDir"} = "/usr/webserver/content/snow/chat/";
    $admin{"htmlURL"} = "http://snow.utoronto.ca/chat/";
    $admin{"msgLifeSpan"} = "1800"; # 30 min
    $admin{"chatIDLifeSpan"} = "2678400"; # 1 month
    $admin{"chatSessionLifeSpan"} = "3600"; # 1 hour
    $admin{"chatName"} = "Accessible Chat";
    $admin{"chatIDListFlag"} = 0;
    $admin{"returnL"} = "http://atrc.utoronto.ca/";
    $admin{"returnT"} = "Return to the ATRC";
    $admin{"adminPass"} = "temppass";
    $admin{"maxChar"} = 200;
}

sub letterToNumber {
    $letter = @_[0];
    if ($letter =~ /0/i) { return 0; }
    if ($letter =~ /1/i) { return 1; }
    if ($letter =~ /2/i) { return 2; }
    if ($letter =~ /3/i) { return 3; }
    if ($letter =~ /4/i) { return 4; }
    if ($letter =~ /5/i) { return 5; }
    if ($letter =~ /6/i) { return 6; }
    if ($letter =~ /7/i) { return 7; }
    if ($letter =~ /8/i) { return 8; }
    if ($letter =~ /9/i) { return 9; }
    if ($letter =~ /a/i) { return 10; }
    if ($letter =~ /b/i) { return 11; }
    if ($letter =~ /c/i) { return 12; }
    if ($letter =~ /d/i) { return 13; }
    if ($letter =~ /e/i) { return 14; }
    if ($letter =~ /f/i) { return 15; }
    if ($letter =~ /g/i) { return 16; }
    if ($letter =~ /h/i) { return 17; }
    if ($letter =~ /i/i) { return 18; }
    if ($letter =~ /j/i) { return 19; }
    if ($letter =~ /k/i) { return 20; }
    if ($letter =~ /l/i) { return 21; }
    if ($letter =~ /m/i) { return 22; }
    if ($letter =~ /n/i) { return 23; }
    if ($letter =~ /o/i) { return 24; }
    if ($letter =~ /p/i) { return 25; }
    if ($letter =~ /q/i) { return 26; }
    if ($letter =~ /r/i) { return 27; }
    if ($letter =~ /s/i) { return 28; }
    if ($letter =~ /t/i) { return 29; }
    if ($letter =~ /u/i) { return 30; }
    if ($letter =~ /v/i) { return 31; }
    if ($letter =~ /w/i) { return 32; }
    if ($letter =~ /x/i) { return 33; }
    if ($letter =~ /y/i) { return 34; }
    if ($letter =~ /z/i) { return 35; }
    return 36;
}

sub printFormStart {
    ($actionStrT, $functionStrT, $targetStrT) = @_;
    print "<form action=\"$actionStrT\" name=\"f1\" method=\"post\" target=\"$targetStrT\">
           <input type=\"hidden\" name=\"chatID\" value=\"$chatID\" />
           <input type=\"hidden\" name=\"uniqueID\" value=\"$prefs{'uniqueID'}\" />
           <input type=\"hidden\" name=\"function\" value=\"$functionStrT\" />\n";
}

sub printTableLeft {
    $printStrT = @_[0];
    print "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">
           <tr><td align=\"left\" bgColor=\"$prefs{'lightBack'}\">$printStrT</td></tr></table>\n";
}

sub printTableRight {
    $printStrT = @_[0];
    print "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">
           <tr><td align=\"right\" bgColor=\"$prefs{'lightBack'}\">$printStrT</td></tr></table>\n";
}

sub printTableDark {
    $printStrT = @_[0];
    print "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">
           <tr><td align=\"left\" bgColor=\"$prefs{'darkBack'}\">$printStrT</td></tr></table>\n";
}

sub printTableSplit {
    ($printStrT1, $printStrT2)  = @_;
    print "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">
    <tr><td align=\"left\" bgColor=\"$prefs{'lightBack'}\">$printStrT1</td>
    <td bgColor=\"$prefs{'lightBack'}\" align=\"right\">$printStrT2</td></tr></table>\n";
}

sub printHead {
    ($titleT) = @_[0];
    ($extratag) = @_[1];
    print "<html>\n<head>\n<title>\n$admin{'chatName'}: $titleT</title>\n$extratag</head>\n";
}

sub printStylesheet {
    $h3SizeT = $prefs{"fontSize"} + 4;
    $h4SizeT = $prefs{"fontSize"} + 2;
    #$aSizeT = $prefs{"fontSize"} + 1;
    print "<style type=\"text/css\"><!--
    BODY { margin: 5; background-color: $prefs{'back'}; color: $prefs{'front'}; font-family: $prefs{'fontFace'}; font-size: $prefs{'fontSize'}; }
    TD { font-family: $prefs{'fontFace'}; font-size: $prefs{'fontSize'}; }
    LI { font-family: $prefs{'fontFace'}; font-size: $prefs{'fontSize'}; }
    UL { margin-left: 40; margin-right: 40; margin-top: 5; margin-bottom: 5; }
    H3 { font-size: $h3SizeT; margin: 0; font-family: $prefs{'fontFace'}; }
    H4 { font-size: $h4SizeT; margin: 0; font-family: $prefs{'fontFace'}; }
    B { font-size: $h4SizeT; }
    A { font-size: $prefs{'fontSize'}; font-weight: bold; color: $prefs{'front'}; text-decoration: underline; }
    A:hover { font-size: $prefs{'fontSize'}; font-weight: bold; background-color: $prefs{'darkBack'}; text-decoration: underline; }
    P { margin-left: 0; margin-right: 0; margin-top: 0; margin-bottom: 10; padding-left: 20; padding-right: 20; padding-top: 5; padding-bottom: 10; font-family: $prefs{'fontFamily'}; font-size: $prefs{'fontSize'}; }
    P.light { background-color: $prefs{'lightBack'}; font-family: $prefs{'fontFace'}; font-size: $prefs{'fontSize'}; }
    FORM { margin-left: 0; margin-right: 0; margin-top: 10; margin-bottom: 10; }
    --></style>\n";
}

sub howManyMessages {
    $topMsgNum = 0;
    $bottomMsgNum = 0;
    opendir(MSGS,"$cgiDIR"."msgs") || &printError($systemtext[29],"$!");
    @msgs = readdir(MSGS);
    closedir(MSGS);
    foreach $msgFileT (@msgs) {
        if ($msgFileT =~ /.message/) {
            $msgFileT =~ s/.message//;
            if ($msgFileT > $topMsgNum) { $topMsgNum = $msgFileT; }
            if ($msgFileT < $bottomMsgNum || $bottomMsgNum == 0) { $bottomMsgNum = $msgFileT; }
        }
    }
    #print "Got messages from $cgiDIR"."msgs $topMsgNum\n";
}

sub postMessage {
    ($posterChatIDT, $messageT) = @_;
    &howManyMessages();
    $topMsgNum ++;

    chomp ($posterChatIDT);
    chomp ($message);

    if (index($posterChatIDT,"!") == length($posterChatIDT)-1) {
        $class = "system";
        chop ($posterChatIDT);
    }
    elsif (index($posterChatIDT,"#") == length($posterChatIDT)-1) {
        $class = "hidden";
        chop ($posterChatIDT);
    }
    else {
        open (CL, "<$cgiDIR"."users/$posterChatIDT.al") || &printError($systemtext[31],"$!");
        $class = <CL>;
        $class = <CL>;
        chomp ($class);
    }

    open (MSG,">$cgiDIR"."msgs/$topMsgNum.message") || &printError($systemtext[31],"$!");
    print MSG "$posterChatIDT\n$messageT\n$class\n";
    close (MSG);
    chmod (0666, "$cgiDIR"."msgs/$topMsgNum.message");

    if ($admin{"produceTran"} > 0) {
        if ($class eq "system" || $class eq "hidden") {
            ($sec,$min,$hour) = gmtime(time);
            &printToTran("<tr class=\"$class\"><td>$posterChatIDT ($hour:$min)</td><td>$messageT</td></tr>");
        } else {
            &printToTran("<tr class=\"$class\"><td>$posterChatIDT</td><td>$messageT</td></tr>");
        }
    }
}

sub messageColours {
   print "<style type=\"text/css\"><!--\n";
   if ($prefs{"colours"} =~ /blackYellow/ || $prefs{"colours"} =~ /blueWhite/ || $prefs{"colours"} =~ /blackWhite/) {
      print "  .system { color: #ff0000 }\n";
      print "  .s0 { color: #CCCCFF }\n";
      print "  .s1 { color: #9999FF }\n";
      print "  .s2 { color: #FF00FF }\n";
      print "  .s3 { color: #FF99FF }\n";
      print "  .s4 { color: #CC9999 }\n";
      print "  .s5 { color: #FF6633 }\n";
      print "  .s6 { color: #FF9900 }\n";
      print "  .s7 { color: #FFCC00 }\n";
      print "  .s8 { color: #FFFF00 }\n";
      print "  .s9 { color: #CCFFCC }\n";
      print "  .s10 { color: #66CCCC }\n";
      print "  .s11 { color: #00FF00 }\n";
      print "  .s12 { color: #00CC99 }\n";
      print "  .s13 { color: #66FFFF }\n";
      print "  .s14 { color: #00CCFF }\n";
      print "  .s15 { color: #00FFFF }\n";
   }
   else {
      print "  .system { color: #ff0000 }\n";
      print "  .s0 { color: #006600 }\n";
      print "  .s1 { color: #009933 }\n";
      print "  .s2 { color: #003399 }\n";
      print "  .s3 { color: #3300FF }\n";
      print "  .s4 { color: #336699 }\n";
      print "  .s5 { color: #0066FF }\n";
      print "  .s6 { color: #666633 }\n";
      print "  .s7 { color: #996600 }\n";
      print "  .s8 { color: #CC6666 }\n";
      print "  .s9 { color: #663366 }\n";
      print "  .s10 { color: #990066 }\n";
      print "  .s11 { color: #CC33CC }\n";
      print "  .s12 { color: #9966FF }\n";
      print "  .s13 { color: #CC00FF }\n";
      print "  .s14 { color: #FF6633 }\n";
      print "  .s15 { color: #CC6666 }\n";
   }
   print "--></style>\n";
}

sub nextColourClass {
    $senderT = @_[0];

    ## hash algorithm
    $num = 0;
    $len = length($senderT);
    for ($j = 0; $j < $len; $j++) {
        $num += &letterToNumber(chop ($senderT));
    }
    $num %= 16;

    ## read in hash table
    open (CLR, "<$cgiDIR"."colour.rcd");
    @clrs = <CLR>;
    close (CLR);

    ## scan through table and see if there's any other class that still hasn't been used as many times
    $i = $num;
    $pos = $num;
    $lowest = $clrs [$num];
    do {
        $i++;
        if ($i > 15) {
            $i = 0;
        }
        if ($clrs[$i] < $lowest) {
            $lowest = $clrs[$i];
            $pos = $i;
        }
        elsif ($clrs [$i] - $lowest > 1) {
            $clrs [$i] = $lowest + 1;
            $clrs [$i] = "$clrs[$i]\n";
        }
    } while ($i != $num);
    $clrs[$pos]++;
    $clrs[$pos] = "$clrs[$pos]\n";

    ## save hash table
    open (CLR, "> $cgiDIR"."colour.rcd");
    print CLR @clrs;
    close (CLR);

    ## return class
    $class = "s".$pos;
    return $class;
}

sub resetColourClass {
    $num = substr(@_[0], 1);

    open (CLR, "<$cgiDIR"."colour.rcd");
    @clrs = <CLR>;
    close (CLR);

    chomp ($clrs[$num]);
    $clrs [$num]--;
    if ($clrs [$num] < 0) {
         $clrs [$num] = 0;
    }
    $clrs[$num] = "$clrs[$num]\n";

    open (CLR, "> $cgiDIR"."colour.rcd");
    print CLR @clrs;
    close (CLR);
}

sub printToTran {
        $tranStrT = @_[0];
        open (TRAN,">> $tranDir$admin{'tranFile'}") || &printError($systemtext[33],"$!");
        print TRAN "$tranStrT\n";
        close(TRAN);
}

sub deleteUser {
    $delChatIDT = @_[0];
    unlink ("$cgiDIR"."users/$delChatIDT.prefs");
    unlink ("$cgiDIR"."users/$delChatIDT.la");
    unlink ("$cgiDIR"."users/$delChatIDT.al");
    if (-e "$htmlDir$delChatIDT.html") { unlink ("$htmlDir$delChatIDT.html"); }
}

sub forcelogout {
    print "<script type=\"text/javascript\" language=\"javascript\"><!-- 
           onunload = function() {
           if ((window.event.clientX<0) && (window.event.clientY<0)) 
               window.open ('$miscURL?function=logout&chatID=$chatID&uniqueID=$uniqueID&language=$language');
           }
           //--></script>";
}

return 1;

